package cn.com.qmth.examcloud.core.oe.student.face.service;

import com.alibaba.fastjson.JSONObject;

import java.io.File;

/**
 * @Description 人脸对比接口
 * @Author lideyin
 * @Date 2019/8/5 17:37
 * @Version 1.0
 */
public interface FaceCompareService {

	/**
	 * 通过face++得到人脸比对结果
	 *
	 * @param baseFaceToken 第一张人脸照片token
	 * @param image_url2 第二张人脸照片路径
	 * @return JSONObject
	 * @see https://console.faceplusplus.com.cn/documents/4887586
	 */
	JSONObject getFaceppCompareResultByUrl(String baseFaceToken, String image_url2);

	JSONObject getFaceppCompareResultByFile(String baseFaceToken, File tempFile);
}
