package cn.com.qmth.examcloud.core.oe.student.face.service.impl;

import cn.com.qmth.examcloud.core.oe.common.repository.ExamCaptureQueueRepo;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamCaptureRepo;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamRecordDataRepo;
import cn.com.qmth.examcloud.core.oe.common.service.GainBaseDataService;
import cn.com.qmth.examcloud.core.oe.student.api.OeHandleByExamCaptureQueueFailedDisposeService;
import cn.com.qmth.examcloud.core.oe.student.face.service.ExamCaptureQueueFailedService;
import cn.com.qmth.examcloud.core.oe.student.face.service.ExamCaptureService;
import cn.com.qmth.examcloud.exchange.inner.api.SmsCloudService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

/**
 * @author chenken
 * @date 2018年11月29日 下午12:39:43
 * @company QMTH
 * @description 抓拍失败处理
 */
@Service("examCaptureQueueFailedService")
public class ExamCaptureQueueFailedServiceImpl implements ExamCaptureQueueFailedService {

    private static final Logger log = LoggerFactory.getLogger(ExamCaptureQueueFailedServiceImpl.class);

    @Autowired
    private ExamCaptureService examCaptureService;

    @Autowired
    private ExamCaptureQueueRepo examCaptureQueueRepo;

    @Autowired
    private ExamCaptureRepo examCaptureRepo;

    @Autowired
    private ExamRecordDataRepo examRecordDataRepo;

    @Autowired
    private GainBaseDataService gainBaseDataService;

    @Autowired
//    private SendSmsCloudService sendSmsCloudService;
    private SmsCloudService smsCloudService;

    @Autowired
    private OeHandleByExamCaptureQueueFailedDisposeService oeHandleByExamCaptureQueueFailedDisposeService;

    @Value("${$capture.queue.failed.max.monitor.num}")
    private Long queueFailedMaxMonitorNum;

//    @Value("${$capture.sms.phones}")
//    private String captureSmsPhones;

//    @Value("${$capture.sms.sign}")
//    private String captureSmsSign;

//    @Value("${$capture.sms.template.code}")
//    private String captureSmsTemplateCode;

    @Override
    public void examCaptureQueueFailedDispose() throws Exception {
//        //处理前失败照片数量
//        String currentDay = new SimpleDateFormat("yyyy-MM-dd").format(new Date());
//
//        long failedQueueSizeBefore = examCaptureQueueRepo.countFailedExamCaptureQueue(currentDay);
//        List<ExamCaptureQueueEntity> examCaptureQueueList = examCaptureQueueRepo.findFailedExamCaptureQueue();
//        if (examCaptureQueueList == null || examCaptureQueueList.size() == 0) {
//            return;
//        }
//        Set<Long> examRecordDataIdList = new HashSet<Long>();
//        for (ExamCaptureQueueEntity examCaptureQueue : examCaptureQueueList) {
//            examRecordDataIdList.add(examCaptureQueue.getExamRecordDataId());
//        }
//        for (Long examRecordDataId : examRecordDataIdList) {
//            List<ExamCaptureQueueEntity> currentQueueList = examCaptureQueueList.stream().filter((e) -> {
//                return e.getExamRecordDataId().equals(examRecordDataId);
//            }).collect(Collectors.toList());
//            ExamRecordDataEntity examRecordData = GlobalHelper.getEntity(examRecordDataRepo, examRecordDataId, ExamRecordDataEntity.class);
//            /**
//             * 不在考试中 && 有警告未审核
//             */
//            if (examRecordData != null
//                    && examRecordData.getExamRecordStatus() != ExamRecordStatus.EXAM_ING
//                    && (examRecordData.getIsWarn() && !examRecordData.getIsAudit())) {
//                int flag = 0;
//                for (ExamCaptureQueueEntity examCaptureQueue : currentQueueList) {
//                    String errorMsg = examCaptureQueue.getErrorMsg();
//                    //如果处理不了的图片直接跳过，不过任何处理，只有可能误处理的才去处理
//                    if (CommonUtil.isJson(errorMsg)) {
//                        JSONObject jsonObject = new JSONObject(errorMsg);
//                        if (jsonObject.has(Constants.ERROR_MSG)) {
//                            String errorMsgContent = jsonObject.getString(Constants.ERROR_MSG);
//                            //这些错误不重新检测,具体错误看:https://console.faceplusplus.com.cn/documents/4887586
//                            if (errorMsgContent.indexOf("IMAGE_ERROR_UNSUPPORTED_FORMAT") > -1
//                                    || errorMsgContent.indexOf("INVALID_IMAGE_URL") > -1
//                                    || errorMsgContent.indexOf("INVALID_IMAGE_SIZE") > -1
//                                    || errorMsgContent.indexOf("IMAGE_FILE_TOO_LARGE") > -1) {
//                                continue;//跳过处理不了的照片
//                            }
//                        }
//                    }
//                    qexamCaptureService.disposeFaceCompare(examCaptureQueue);
//                    if (examCaptureQueue.getStatus()== ExamCaptureQueueStatus.PROCESS_FACE_COMPARE_COMPLETE){
//                        examCaptureService.disposeBaiDuFaceLiveness(examCaptureQueue);
//                    }
//
//                    flag++;
//                }
//                //表示处理过
//                if (flag > 0) {
//                    HandleByExamCaptureQueueFailedDisposeReq req = new HandleByExamCaptureQueueFailedDisposeReq();
//                    req.setExamRecordDataId(examRecordDataId);
//                    //如果有重新处理过的图片，则需要重新计算考试记录相关数据。类似于交卷
//                    oeHandleByExamCaptureQueueFailedDisposeService.handleByExamCaptureQueueFailedDispose(req);
//                }
//            }
//        }
//        //处理后失败照片数量
//        long failedQueueSizeAfter = examCaptureQueueRepo.countFailedExamCaptureQueue(currentDay);
//        //处理后的数量>queueFailedMaxMonitorNum,而且大于处理之前的数量
//        if (failedQueueSizeAfter > queueFailedMaxMonitorNum && (failedQueueSizeAfter > failedQueueSizeBefore)) {
//            log.info("本次抓拍照片失败处理，处理前数量:" + failedQueueSizeBefore + ",处理后数量:" + failedQueueSizeAfter);
//            CaptureFailedAlarmReq req = new CaptureFailedAlarmReq();
//            req.setTotalCount(Integer.valueOf(failedQueueSizeBefore + ""));
//            req.setErrorCount(Integer.valueOf(failedQueueSizeAfter + ""));
//            req.setTemplateCode(captureSmsTemplateCode);
//            req.setSign(captureSmsSign);
//            req.setPhone(captureSmsPhones);
//            SendSmsReq sendSmsReq = new SendSmsReq();
//            if (StringUtils.isNoneBlank(captureSmsPhones)) {
//                sendSmsReq.setPhoneList(Arrays.asList(captureSmsPhones.split(",")));
//                HashMap<String, String> paramMap = new HashMap<>();
//                paramMap.put("totalCount", failedQueueSizeBefore + "");
//                paramMap.put("errorCount", failedQueueSizeAfter + "");
//                sendSmsReq.setParams(paramMap);
//                sendSmsReq.setSmsAssemblyCode("SMS");
//                smsCloudService.sendSms(sendSmsReq);
//            }
//
//        }
    }
}
